<?php
/**
 * @version    
 * @package    ZiMB Manager
 * @subpackage Plugins
 * @license    GNU/GPL
 */
 
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();
 
jimport('joomla.event.plugin');
 
/**
 * ZiMB Authentication - Allows DB2 Authentication for iSeries Hosted Joomla! Installations.  
 *
 * @package    ZiMB Manager
 * @subpackage Plugins
 * @license    GNU/GPL
 */
class plgContentZiMBDojoEnable extends JPlugin
{
    /**
     * Constructor
     *
     * For php4 compatability we must not use the __constructor as a constructor for plugins
     * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
     * This causes problems with cross-referencing necessary for the observer design pattern.
     *
     * @param object $subject The object to observe
     * @since 1.5
     */
    function plgContentZiMBDojoEnable(& $subject) {
        parent::__construct($subject);
		// load plugin parameters
        $plugin = JPluginHelper::getPlugin("content", "ZiMBDojoEnable");
		
		$this->params = new JParameter($plugin->params);
		$this->_name = $plugin->name;
		
    }
	
	function onPrepareContent( &$article, &$params, $page = 0)
    {
        global $mainframe;
		
		$doc = &JFactory::getDocument();
		
		$dj = new ZIMB_Dojo();
		$dj->JDocumentEnable($doc);
	
		// Pull out Requires From Article
		
		// Is between <ZIMBDojoRequire> tags.
		$openTagLoc = strpos($article->text, "<ZIMBDojoRequire>");
		$closeTagLoc = strpos($article->text, "</ZIMBDojoRequire>");
		if ($openTagLoc !== false && $closeTagLoc !== false)
		{
			$requires = explode("\n", substr($article->text, $openTagLoc + 17, $closeTagLoc - $openTagLoc - 17));
			$requireDec = "";
			if (count($requires) > 0)
			{
				foreach ($requires as $require)
				{
					$piece = str_replace("\n", "", $require);
					$piece = str_replace("\r", "", $require);
					if (!strpos($piece, "<ZIMBDojoRequire>") && $piece != "")
					{
						$requireDec .= 'dojo.require("'.$piece.'");' . "\n";
					}
				}
			}
			$doc->addScriptDeclaration($requireDec);
			$article->text = substr_replace($article->text, "", $openTagLoc, $closeTagLoc - $openTagLoc + 18);
		}
		
		
		// Get <ZIMBJSInclude> Tags For Javascript Includes
		$openTagLoc = strpos($article->text, "<ZIMBJSInclude>");
		$closeTagLoc = strpos($article->text, "</ZIMBJSInclude>");
		if ($openTagLoc !== false && $closeTagLoc !== false)
		{
			$javascript = substr($article->text, $openTagLoc + 15, $closeTagLoc - $openTagLoc - 15);
			$doc->addScriptDeclaration($javascript);
			
			$article->text = substr_replace($article->text, "", $openTagLoc, $closeTagLoc - $openTagLoc + 16);
		}
    }

}
?>