var currentEditTable;
var currentEditSchema;
var newRowCount = 0;
function init()
{
	// Do initial work here.
}



// Event handlers


function mnuTableViewTop1000RowsClicked(menuItem)
{
	var table = menuItem.item.name;
	var schema = menuItem.item.schema;
	//console.log('Loading top 1000 rows of table ' + table);

	//console.dir(menuItem.item);
	var params;
	
	// Call out to get json for grid store.
	var data = [];
	var url = "";
	
	dojo.xhrGet({
		url: url,
		handleAs: "json",
		content: {
			option: 'com_zimbcore',
			view: 'DataManager',
			format: 'ajax',
			task: 'fetchRows',
			table: table,
			schema: schema,
			maxRows: 1000
		
		},
		load: function(data) {
			params = {
				data: data	
			};
			var store = new dojo.data.ItemFileReadStore(params);
							
			// Create Grid and place in content pane.
			var layout = [];
			dojo.forEach(menuItem.item.children, function(item) {
				layout.push({field: item.name[0], name: item.name[0]});	
	
			});
			var grid = dijit.byId('gridGrid');
			if (grid)
			{
				grid.selection.clear();
				grid.setStore(store);
				grid.setStructure(layout);
				
			}
			else
			{
				var grid = new dojox.grid.DataGrid({
					store: store,
					structure: layout,
					id: 'gridGrid',
					jsId: 'gridGrid',
					clientSort: true,
					style: "width: auto; height: 100%;"

				}, document.createElement('div'));		
			}
			dojo.byId('centerPane').appendChild(grid.domNode);
			grid.startup();	
			
		},
		error: function(response) {
			console.dir(response);
		}

	});	
	

	
}


function mnuTableEditTop200RowsClicked(menuItem)
{
	var table = menuItem.item.name;
	var schema = menuItem.item.schema;
	//console.log('Loading top 1000 rows of table ' + table);

	//console.dir(menuItem.item);
	var params;
	
	// Call out to get json for grid store.
	var data = [];
	var url = "";
	
	dojo.xhrGet({
		url: url,
		handleAs: "json",
		content: {
			option: 'com_zimbcore',
			view: 'DataManager',
			format: 'ajax',
			task: 'fetchRows',
			table: table,
			schema: schema,
			maxRows: 200
		
		},
		load: function(data) {
			currentEditTable = table;
			currentEditSchema = schema;
			params = {
				data: data	
			};
			var store = new dojo.data.ItemFileWriteStore(params);
			dojo.connect(store, 'onSet', gridCellUpdate);

				
			// Create Grid and place in content pane.
			var layout = [];
			dojo.forEach(menuItem.item.children, function(item) {
				layout.push({field: item.name[0], name: item.name[0], editable: true});	
	
			});
			var gridMenu = dijit.byId('mnuGrid');
			var grid = dijit.byId('gridGrid');
			if (grid)
			{
				grid.selection.clear();
				grid.setStore(store);
				grid.setStructure(layout);
				
			}
			else
			{
				var grid = new dojox.grid.DataGrid({
					store: store,
					structure: layout,
					id: 'gridGrid',
					jsId: 'gridGrid',
					clientSort: true,
					style: "width: auto; height: 100%;",
					headerMenu: gridMenu,
					onRowContextMenu: function(evt) {
						var target = evt.rowNode.gridRowIndex;
						dijit.byId('gridGrid').selection.setSelected(target, true);
						var gm = dijit.byId('mnuGridRow');
						gm._openMyself(evt);
					}

				}, document.createElement('div'));		
			}
			
			dojo.byId('centerPane').appendChild(grid.domNode);
			grid.startup();	
			console.dir(grid.rowCount);
			if (grid.rowCount == 0)
			{
				addRowClicked();
			}
		},
		error: function(response) {
			console.dir(response);
		}

	});	

}


// Methods


function gridCellUpdate(item, attribute, oldValue, newValue)
{
	var rowCount = parseInt(item.rowCount);
	
	if (rowCount > -1)
	{
		// Update existing Row
		var url = "";
		dojo.xhrGet({
			url: url,
			handleAs: "json",
			content: {
				option: 'com_zimbcore',
				view: 'DataManager',
				format: 'ajax',
				task:"updateRow",
				rowCount: rowCount,
				attribute: attribute,
				oldValue: oldValue,
				newValue: newValue,
				table: currentEditTable,
				schema: currentEditSchema
			},
			load: function(result) {
			
			
			},
			error: function(result) {
			
			}
		});
	}
	else
	{
		// Insert Row
		var url = "";
		dojo.xhrGet({
			url: url,
			handleAs: "json",
			content: {
				option: 'com_zimbcore',
				view: 'DataManager',
				format: 'ajax',
				task:"addRow",
				rowCount: rowCount,
				attribute: attribute,
				newValue: newValue,
				table: currentEditTable,
				schema: currentEditSchema
			},
			load: function(result) {
				// Result should be the new row as it has been updated.
				var grid = dijit.byId('gridGrid');
				var structure = grid.structure;
				dojo.forEach(structure, function(fieldName) {
					
					item[fieldName.field] = [result[fieldName.field]];	
					
				})
				item.rowCount = [result.rowCount];
				console.dir(result);
				console.dir(item);
				grid.updateRow(result.rowCount);
			},
			error: function(result) {
			
			}
		});
	}
}
function addRowClicked()
{
	var grid = dijit.byId('gridGrid');
	var store = grid.store;
	//console.dir(grid);
	try
	{
		//grid.addRow();
		newRowCount++;
		
		store.newItem({'rowCount':-1 * newRowCount});
	}
	catch(err)
	{
		//console.dir(err);
		//console.dir(store);
	}
	//grid.store.newItem();
	
}
function deleteRowClicked(event)
{
	var grid = dijit.byId('gridGrid');
	var selectedItems = grid.selection.getSelected();
	
	if (selectedItems.length)
	{
		var selectedIndexes = [];
		dojo.forEach(selectedItems, function(item) {
			if (item !== null)
			{
				selectedIndexes.push(item.rowCount[0]);
				// Delete row in DOJO Grid.
				grid.store.deleteItem(item);
			}
		});
		var url = "";
		// Send request to delete row on server.
		dojo.xhrGet({
			url: url,
			handleAs: "json",
			content: {
				option: 'com_zimbcore',
				view: 'DataManager',
				format: 'ajax',
				task: "deleteRow",
				indexes: dojo.toJson(selectedIndexes),
				table: currentEditTable,
				schema: currentEditSchema
			},
			load: function(result) {
				console.dir(result);
			
			},
			error: function(result) {
			
			
			
			}
		});
	
		
	} 
	grid.selection.clear();
	
	
}
function composeSQLClicked()
{
	var dlg = dijit.byId('dlgRunSQL');
	dlg.show();
}
function reloadTree()
{
	var tree = dijit.byId('trFileManager');
	var store = tree.store;
	console.dir(store);
	//var params = {
	//	id: 'treeStore',
	//	url: tree.store.url
	//
	//};
	//var store = new dojo.data.ItemFileReadStore(params);
	//tree.store = store;
	//jsId = "treeStore" 
        //dojoType="dojo.data.ItemFileReadStore" 
        //url = "<?php echo $baseUrl;?>Datamanager/tableeditorcallback?functionCode=buildTree">
	//console.dir(tree);
}