<?php

require_once ('ZIMB/Db/Table/Abstract.php');

class ZIMB_Base_ZIMBBase extends ZIMB_Db_Table_Abstract {
	
	public static function returnTableClass($schema, $table, $primary = null)
	{
		
		$className = "ZIMB_Data_Generated_$schema$table";
		try
		{
			@Zend_Loader::LoadClass($className);
		}
		catch(Exception $e)
		{
			$tableData = Zend_Db_Table_Abstract::getDefaultAdapter()->describeTable($table, $schema);
			$primaryKey = false;
			foreach ($tableData as $name=>$value)
			{
				
				if ($value["PRIMARY"] == true)
				{
					$primaryKey = $name;
					break;
				}
			}
			if (!$primaryKey)
			{
				$primary = array_keys($tableData);
				$primary = $primary[0];	
			}
			$insertClass = new Zend_CodeGenerator_Php_Class();
			$insertClass->setExtendedClass("ZIMB_Base_ZIMBBase");
			$insertClass->setName("ZIMB_Data_Generated_" . $schema . $table);
			$parms = array();
			$parms[] = array(
	            			'name'         => '_name',
	            			'visibility'   => 'protected',
	            			'defaultValue' => $table
	        		);
	        	$parms[] = array(
	            			'name'         => '_schema',
				        'visibility'   => 'protected',
				        'defaultValue' => $schema
	        		);
	        	if ($primary)
	        	{
	        		$parms[] = array(
	        			'name' 	       => '_primary',
	        			'visibility'   => 'protected',
	        			'defaultValue' => $primary
	        		
	        		);
	        	}
			$insertClass->setProperties($parms);
	    		$file = new Zend_CodeGenerator_Php_File(array(
	    			'classes'  => array($insertClass)));
	    		$code = $file->generate();
			file_put_contents(JPATH_LIBRARIES . "/ZIMB/Data/Generated/" . $schema . $table . ".php", $code);
		}
		$tableObject = new $className();
		return $tableObject;

	}
	public function get_cols()
	{
		if ($this->_cols)
		{
			return $this->_cols;
		}
		$cols = array();
		foreach ($this->_db->describeTable($this->_name, $this->_schema) as $name=>$value)
		{
			$cols[] = $name;
		}	
		return $cols;
	}
	public function returnIdentityColumns()
	{
		$tableInfo = $this->_db->describeTable($this->_name, $this->_schema);
		$identity = array();
		foreach ($tableInfo as $name=>$column)
		{	
			
			if ($column["IDENTITY"])
			{
				$identity[] = $name;
			}
			if (count($identity) == 0)
			{
				return false;
			}
			else
			{
				return $identity;
			}
		}
	}
	public function returnPrimaryKeys()
	{
	
	}
	public function returnInsertArray($attribute, $value)
	{
		$tableInfo = $this->_db->describeTable($this->_name, $this->_schema);
		
		
		$data = array();
		foreach ($tableInfo as $columnName => $columnData)
		{
					
			if (!$columnData["IDENTITY"])
			{
				if ($columnName == $attribute)
				{
					$data[$attribute] = $value;
				}
				else
				{
					$defaultValue = "";
					
					$numericTypes = array("INTEGER", "SMALLINT", "BIGINT", "DECIMAL", "NUMERIC");
					if (in_array(trim($columnData["DATA_TYPE"]), $numericTypes))
					{
							$defaultValue = 0;
							
					}
					$dateTypes = array("DATE");
					if (in_array(trim($columnData["DATA_TYPE"]), $dateTypes))
					{
							$defaultValue = '0001-01-01';
							
					}
					$timeTypes = array("TIME");
					if (in_array(trim($columnData["DATA_TYPE"]), $timeTypes))
					{
							$defaultValue = '00:00:00';
							
					}
					$data[$columnName] = $defaultValue;
				}
			}
		
		}
		return $data;
	}
	
}

?>